Skip to main content

client.responses.create()

Creates a model response. Provide text or image inputs to generate text or JSON outputs. Have the model call your own custom code or use built-in tools like web search or file search to use your own data as input for the model’s response.

Method Signature

Request Parameters

string
required
Model ID used to generate the response, like gpt-4o or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.
string | object
Text, image, or file inputs to the model, used to generate a response.Can be a simple string or a structured object with role and content.Learn more:
string
A system (or developer) message inserted into the model’s context.When using along with previous_response_id, the instructions from a previous response will not be carried over to the next response. This makes it simple to swap out system (or developer) messages in new responses.
boolean
default:"false"
If set to true, the model response data will be streamed to the client as it is generated using server-sent events. See Streaming responses for more information.
number
What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both.
integer
An upper bound for the number of tokens that can be generated for a response, including visible output tokens and reasoning tokens.
number
An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.We generally recommend altering this or temperature but not both.
array
An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter.We support the following categories of tools:
  • Built-in tools: Tools that are provided by OpenAI that extend the model’s capabilities, like web search or file search. Learn more about built-in tools.
  • MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools.
  • Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling.
object | string
How the model should select which tool (or tools) to use when generating a response. See the tools parameter to see how to specify which tools the model can call.
boolean
Whether to allow the model to run tool calls in parallel.
string
The unique ID of the previous response to the model. Use this to create multi-turn conversations. Learn more about conversation state. Cannot be used in conjunction with conversation.
object
The conversation that this response belongs to. Items from this conversation are prepended to input_items for this response request. Input items and output items from this response are automatically added to this conversation after this response completes.
object
Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more:
object
gpt-5 and o-series models onlyConfiguration options for reasoning models.
object
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
boolean
Whether to store the generated model response for later retrieval via API.
boolean
Whether to run the model response in the background. Learn more.
object
Reference to a prompt template and its variables. Learn more.
string
Used by OpenAI to cache responses for similar requests to optimize your cache hit rates. Replaces the user field. Learn more.
string
The retention policy for the prompt cache. Set to 24h to enable extended prompt caching, which keeps cached prefixes active for longer, up to a maximum of 24 hours. Learn more.Options: in-memory, 24h
string
A stable identifier used to help detect users of your application that may be violating OpenAI’s usage policies. The IDs should be a string that uniquely identifies each user, with a maximum length of 64 characters. We recommend hashing their username or email address, in order to avoid sending us any identifying information. Learn more.
string
Specifies the processing type used for serving the request.
  • If set to ‘auto’, then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use ‘default’.
  • If set to ‘default’, then the request will be processed with the standard pricing and performance for the selected model.
  • If set to ‘flex’ or ‘priority’, then the request will be processed with the corresponding service tier.
  • When not set, the default behavior is ‘auto’.
Options: auto, default, flex, scale, priority
string
default:"disabled"
The truncation strategy to use for the model response.
  • auto: If the input to this Response exceeds the model’s context window size, the model will truncate the response to fit the context window by dropping items from the beginning of the conversation.
  • disabled (default): If the input size will exceed the context window size for a model, the request will fail with a 400 error.
Options: auto, disabled
integer
The maximum number of total calls to built-in tools that can be processed in a response. This maximum number applies across all built-in tool calls, not per individual tool. Any further attempts to call a tool by the model will be ignored.
integer
An integer between 0 and 20 specifying the number of most likely tokens to return at each token position, each with an associated log probability.
array
Specify additional output data to include in the model response. Currently supported values are:
  • web_search_call.action.sources: Include the sources of the web search tool call.
  • code_interpreter_call.outputs: Includes the outputs of python code execution in code interpreter tool call items.
  • computer_call_output.output.image_url: Include image urls from the computer call output.
  • file_search_call.results: Include the search results of the file search tool call.
  • message.input_image.image_url: Include image urls from the input message.
  • message.output_text.logprobs: Include logprobs with assistant messages.
  • reasoning.encrypted_content: Includes an encrypted version of reasoning tokens in reasoning item outputs.
array
Context management configuration for this request.
object
Options for streaming responses. Only set this when you set stream: true.

Response Fields

string
Unique identifier for this Response.
string
The object type of this resource - always set to response.
number
Unix timestamp (in seconds) of when this Response was created.
string
Model ID used to generate the response, like gpt-4o or o3.
array
An array of content items generated by the model.The length and order of items in the output array is dependent on the model’s response. Rather than accessing the first item in the output array and assuming it’s an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.
string
Convenience property that aggregates all output_text items from the output list. If no output_text content blocks exist, then an empty string is returned.
string
The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.
object
Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.
number
What sampling temperature to use, between 0 and 2.
number
An alternative to sampling with temperature, called nucleus sampling.
array
An array of tools the model may call while generating a response.
object | string
How the model should select which tool (or tools) to use when generating a response.
boolean
Whether to allow the model to run tool calls in parallel.
number
Unix timestamp (in seconds) of when this Response was completed. Only present when the status is completed.
object
An error object returned when the model fails to generate a Response.
object
Details about why the response is incomplete.
string | array
A system (or developer) message inserted into the model’s context.
object
Set of 16 key-value pairs that can be attached to an object.
string
The unique ID of the previous response to the model.
object
The conversation that this response belonged to.
object
Configuration options for a text response from the model.
object
Configuration options for reasoning models.
object
Reference to a prompt template and its variables.
string
Used by OpenAI to cache responses for similar requests.
string
The retention policy for the prompt cache.
string
A stable identifier used to help detect users of your application that may be violating OpenAI’s usage policies.
string
Specifies the processing type used for serving the request.
string
The truncation strategy to use for the model response.
integer
An upper bound for the number of tokens that can be generated for a response.
integer
The maximum number of total calls to built-in tools that can be processed in a response.
integer
An integer between 0 and 20 specifying the number of most likely tokens to return at each token position.
boolean
Whether to run the model response in the background.

Examples

Basic Text Generation

Vision with Image URL

Vision with Base64 Encoded Image

Async Usage

See Also